using System;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using RR_COM_APILib;

namespace TestRR
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public RR_COM_APILib.API_WrapperClass RR;

        private void Form1_Load(object sender, EventArgs e)
        {
            RR = new RR_COM_APILib.API_WrapperClass();
            RR.Connect("localhost");
        }

        private void GetImage_Click(object sender, EventArgs e)
        {
            Bitmap displayImage;
            displayImage = getImageBitmap("");
            pictureBox1.Image = displayImage;
        }

        private Bitmap getImageBitmap(string marker)
        {
            object width = 0;
            object height = 0;

            object imageData = "";
            Bitmap imageBitmap = null;

            int dimension = 0;

            string RR_Variable;

            RR_Variable = RR.GetVariable("RECEPTION_QUALITY");

            Console.WriteLine("Reception: " + RR_Variable);

            while (dimension == 0)
            {
                dimension = RR.GetDimension(out width, out height);
                Console.WriteLine(dimension + " : " + width + " x " + height);
                //dimension = RR.GetImage(marker, out imageData, out width, out height);
                RR.WaitImage();
            }

            byte[] imageBytes = new byte[(int)width * (int)height];

            imageBytes = (byte[])imageData;

            imageBitmap = BitsToBitmapRGB24(imageBytes, (int)width, (int)height);

            return imageBitmap;

        }

        // Create RGB24 bitmap from Byte array
        public Bitmap BitsToBitmapRGB24(Byte[] bytes, int width, int height)
        {
            //swap RGB to BGR

            Byte tmp;
            for (int x = 3; x < bytes.GetLength(0); x += 3)
            {
                tmp = bytes[(x + 2)];
                bytes[x + 2] = bytes[x];
                bytes[x] = tmp;
            }

            if (bytes.GetLength(0) < width * height * 3)
            {
                return null;
            }

            Bitmap bmp = new Bitmap(width, height, PixelFormat.Format24bppRgb);
            int i;

            BitmapData data = bmp.LockBits(new Rectangle(0, 0, bmp.Width, bmp.Height), ImageLockMode.WriteOnly, bmp.PixelFormat);

            if (data.Stride == width * 3)
            {
                Marshal.Copy(bytes, 0, data.Scan0, width * height * 3);
            }
            else
            {
                for (i = 0; i < bmp.Height; i++)
                {
                    IntPtr p = new IntPtr(data.Scan0.ToInt32() + data.Stride * i);
                    Marshal.Copy(bytes, i * bmp.Width * 3, p, bmp.Width * 3);
                }
            }

            bmp.UnlockBits(data);

            return bmp;
        }

    }
}